/*
 *  Definition of macro core base, common for all macro cores.
 */

function MacroCore() {
	this.power = function() {
		return pmngr.power;
	};

}
// Check whether the core can afford an action.
MacroCore.prototype.canAfford = function(value) {
	if (!value) {
		return true;
	}
	return (this.power() - value) >= 0;
}

// Returns most important item from given set.
MacroCore.prototype.mostValue = function(set) {
	var m = 0;

	for (var item in set) {
		if (set[item] > m) { m = set[item]; }
	}

	var ml = [];
	for (var item in set) {
		if (set[item] === m) { ml.push(item); }
	}

	return ml[randomInt(ml.length)];
}

// Returns and array of items sorted by their priority.
MacroCore.prototype.sortByValue = function(set) {
	var res = [];

	for (var key in set) {

		// irrelevant key
		if (!set[key]) { continue; }

		if (!res.length) {
			// first found
			res.push(key);
			continue;
		}

		var inserted = false;
		for (var i = 0, l = res.length; i < l; i++) {
			// has better prio
			if (set[res[i]] < set[key]) {
				res.splice(i, 0, key);
				inserted = true;
				break;
			}
		}

		if (!inserted) {
			// has lowest prio
			res.push(key);
		}
	}

	return res;
}