/*
 *	Definition of aviation micro cores.
 */

function AirSergeantCore(role, id) {
	MicroCore.call(this, AttackGroup, id);
	this.role = role;
	this.type = 'vtol';
	this.prop = 'VTOL';

	prodCore.unitAmnt[this.type][this.role] += MAX_SQUAD_SIZE;
}

AirSergeantCore.prototype = Object.create(MicroCore.prototype);
AirSergeantCore.prototype.constructor = AirSergeantCore;

AirSergeantCore.prototype.attack = function(target) {
	var coord = defined(target.r) ? target : new Point(target.y, target.x);

	if (distance(this.units.pos, coord) < PRESENCE_RADIUS) {
		// var targets = enumRange(this.units.pos.c, this.units.pos.r, 6, ENEMIES);

		if (enemies.length > 0 && enemies[0].type !== FEATURE) {
			this.units.attack(enemies[0]);
			this.status = state.ENGAGED;
			return;
		} else {
			this.orderDone(target);
			return;
		}
	}
	this.units.move(target);
	this.status = state.MOVING;
}

AirSergeantCore.prototype.bombingRun = function(target, angle) {

}

AirSergeantCore.prototype.rearm = function() {
	this.units.rearm();
}
