/*
 * Base defenses
 *
 * Structure:
 * 	id : string; game idto pass into API functions
 * 	gun : string; NAME of gun used by the structure
 * 	type : string; armor type as per damage modifiers, one of ['strucBunker', 'strucHard', 'strucMedium']
 * 	tech : string; ID of tech needed to unlock this
 */

const defense = {
	// 'Assault Gun Emplacement': 			{id: 'Tower-RotMg', gun: 'Assault Gun', type: 'strucBunker', tech: ''}, // unavailable
	'Flamer Bunker': 					{id: 'PillBox5', gun: 'Flamer', type: 'strucBunker', tech: 'R-Defense-Pillbox05'},
	'Inferno Bunker': 					{id: 'Tower-Projector', gun: 'Inferno', type: 'strucBunker', tech: 'R-Defense-HvyFlamer'},
	// 'Lancer Bunker': 					{id: 'PillBox6', gun: 'Lancer', type: 'strucBunker', tech: ''}, // unavailable
	'Light Cannon Bunker': 				{id: 'PillBox4', gun: 'Light Cannon', type: 'strucBunker', tech: 'R-Defense-Pillbox04'},
	'Heavy Machinegun Bunker': 				{id: 'PillBox1', gun: 'Heavy Machinegun Bunker', type: 'strucBunker', tech: 'R-Defense-Pillbox01'}, // not a turret
	'Plasmite Flamer Bunker': 			{id: 'Plasmite-flamer-bunker', gun: 'Plasmite Flamer', type: 'strucBunker', tech: 'R-Defense-PlasmiteFlamer'},
	'Rotary MG Bunker': 				{id: 'Pillbox-RotMG', gun: '*MG4ROTARY-Pillbox*', type: 'strucBunker', tech: 'R-Defense-RotMG'}, // not a turret
	'Twin Assault Cannon Bunker': 		{id: 'PillBox-Cannon6', gun: 'Twin Assault Cannon', type: 'strucBunker', tech: 'R-Defense-Cannon6'},
	//'Twin Machinegun Bunker': 			{id: 'PillBox2', gun: 'Twin Machinegun Bunker', type: 'strucBunker', tech: ''}, // unavailable

	'AA Flak Cannon Emplacement': 		{id: 'AASite-QuadBof', gun: 'AA Flak Cannon', type: 'strucHard', tech: 'R-Defense-AASite-QuadBof'},
	'AA Flak Cannon Hardpoint': 		{id: 'WallTower-DoubleAAGun', gun: 'AA Flak Cannon', type: 'strucHard', tech: 'R-Defense-WallTower-DoubleAAgun'},
	'Archangel Missile Emplacement': 	{id: 'Emplacement-HvART-pit', gun: 'Archangel Missile', type: 'strucHard', tech: 'R-Defense-HvyArtMissile'},
	'Assault Cannon Hardpoint': 		{id: 'Wall-VulcanCan', gun: 'Assault Cannon', type: 'strucHard', tech: 'R-Defense-Wall-VulcanCan'},
	'Assault Gun Hardpoint': 			{id: 'Wall-RotMg', gun: 'Assault Gun', type: 'strucHard', tech: 'R-Defense-Wall-RotMg'},
	'Avenger Hardpoint': 				{id: 'WallTower-SamSite', gun: 'Avenger SAM', type: 'strucHard', tech: 'R-Defense-WallTower-SamSite'},
	'Avenger SAM Site': 				{id: 'P0-AASite-SAM1', gun: 'Avenger SAM', type: 'strucHard', tech: 'R-Defense-SamSite1'},
	'Cannon Fortress': 					{id: 'X-Super-Cannon', gun: 'Cannon Fortress', type: 'strucHard', tech: 'R-Defense-Super-Cannon'}, // not a turret
	'EMP Cannon Tower': 				{id: 'WallTower-EMP', gun: 'EMP Cannon', type: 'strucHard', tech: 'R-Defense-EMPCannon'},
	//'Flamer Hardpoint': 				{id: 'WallTower05', gun: 'Flamer', type: 'strucHard', tech: ''}, unavailable
	'Flashlight Emplacement': 			{id: 'Emplacement-PrisLas', gun: 'Flashlight', type: 'strucHard', tech: 'R-Defense-PrisLas'},
	'Gauss Cannon Emplacement': 		{id: 'Emplacement-Rail3', gun: 'Gauss Cannon', type: 'strucHard', tech: 'R-Defense-Rail3'},
	'Gauss Cannon Hardpoint': 			{id: 'WallTower-Rail3', gun: 'Gauss Cannon', type: 'strucHard', tech: 'R-Defense-WallTower-Rail3'},
	'Ground Shaker Emplacement': 		{id: 'Emplacement-Howitzer150', gun: 'Ground Shaker', type: 'strucHard', tech: 'R-Defense-HvyHowitzer'},
	'Heavy Cannon Hardpoint': 			{id: 'WallTower04', gun: 'Heavy Cannon', type: 'strucHard', tech: 'R-Defense-WallTower04'},
	'Heavy Laser Emplacement': 			{id: 'Emplacement-HeavyLaser', gun: 'Heavy Laser', type: 'strucHard', tech: 'R-Defense-HeavyLas'},
	'Heavy Machinegun Hardpoint': 		{id: 'WallTower01', gun: 'Heavy Machinegun', type: 'strucHard', tech: 'R-Defense-WallTower01'},
	'Heavy Rocket Bastion': 			{id: 'X-Super-Rocket', gun: 'Heavy Rocket Bastion', type: 'strucHard', tech: 'R-Defense-Super-Rocket'}, // not a turret
	'Hellstorm Emplacement': 			{id: 'Emplacement-RotHow', gun: 'Hellstorm', type: 'strucHard', tech: 'R-Defense-RotHow'},
	'Howitzer Emplacement': 			{id: 'Emplacement-Howitzer105', gun: 'Howitzer', type: 'strucHard', tech: 'R-Defense-Howitzer'},
	'Hyper Velocity Cannon Emplacement':{id: 'Emplacement-HPVcannon', gun: 'Hyper Velocity Cannon', type: 'strucHard', tech: 'R-Defense-Emplacement-HPVcannon'},
	'Hyper Velocity Cannon Hardpoint': 	{id: 'WallTower-HPVcannon', gun: 'Hyper Velocity Cannon', type: 'strucHard', tech: 'R-Defense-WallTower-HPVcannon'},
	'Incendiary Howitzer Emplacement': 	{id: 'Emplacement-Howitzer-Incenediary', gun: 'Incendiary Howitzer', type: 'strucHard', tech: 'R-Defense-Howitzer-Incenediary'},
	//'Inferno Hardpoint': 				{id: 'WallTower-Projector', gun: 'Inferno', type: 'strucHard', tech: ''}, // unavailable
	'Lancer Hardpoint': 				{id: 'WallTower06', gun: 'Lancer', type: 'strucHard', tech: 'R-Defense-WallTower06'},
	'Light Cannon Hardpoint': 			{id: 'WallTower02', gun: 'Light Cannon', type: 'strucHard', tech: 'R-Defense-WallTower02'},
	'Mass Driver Fortress': 			{id: 'X-Super-MassDriver', gun: 'Mass Driver', type: 'strucHard', tech: 'R-Defense-MassDriver'}, // not a turret
	'Medium Cannon Hardpoint': 			{id: 'WallTower03', gun: 'Medium Cannon', type: 'strucHard', tech: 'R-Defense-WallTower03'},
	'Mini-Rocket Battery': 				{id: 'Emplacement-MRL-pit', gun: 'Mini-Rocket Array', type: 'strucHard', tech: 'R-Defense-MRL'},
	'Missile Fortress': 				{id: 'X-Super-Missile', gun: 'Missile Fortress', type: 'strucHard', tech: 'R-Defense-Super-Missile'}, // not a turret
	'Plasma Cannon Emplacement': 		{id: 'Emplacement-PlasmaCannon', gun: 'Plasma Cannon', type: 'strucHard', tech: 'R-Defense-PlasmaCannon'},
	//'Pulse Laser Emplacement': 			{id: 'Emplacement-PulseLaser', gun: 'Pulse Laser', type: 'strucHard', tech: ''}, // unavailable
	'Pulse Laser Hardpoint': 			{id: 'WallTower-PulseLas', gun: 'Pulse Laser', type: 'strucHard', tech: 'R-Defense-WallTower-PulseLas'},
	'Rail Gun Hardpoint': 				{id: 'WallTower-Rail2', gun: 'Rail Gun', type: 'strucHard', tech: 'R-Defense-WallTower-Rail2'},
	'Railgun Emplacement': 				{id: 'Emplacement-Rail2', gun: 'Rail Gun', type: 'strucHard', tech: 'R-Defense-Rail2'},
	'Ripple Rocket Battery': 			{id: 'Emplacement-Rocket06-IDF', gun: 'Ripple Rockets', type: 'strucHard', tech: 'R-Defense-IDFRocket'},
	'Scourge Missile Hardpoint': 		{id: 'WallTower-Atmiss', gun: 'Scourge Missile', type: 'strucHard', tech: 'R-Defense-WallTower-A-Tmiss'},
	'Seraph Missile Battery': 			{id: 'Emplacement-MdART-pit', gun: 'Seraph Missile Array', type: 'strucHard', tech: 'R-Defense-MdArtMissile'},
	'Stormbringer Emplacement': 		{id: 'P0-AASite-Laser', gun: 'Stormbringer AA Laser', type: 'strucHard', tech: 'R-Defense-AA-Laser'},
	'Tank Killer Emplacement': 			{id: 'Emplacement-HvyATrocket', gun: 'Tank Killer', type: 'strucHard', tech: 'R-Defense-HvyA-Trocket'},
	'Tank Killer Hardpoint': 			{id: 'WallTower-HvATrocket', gun: 'Tank Killer', type: 'strucHard', tech: 'R-Defense-WallTower-HvyA-Trocket'},
	'Twin Assault Gun Hardpoint': 		{id: 'WallTower-TwinAssaultGun', gun: 'Twin Assault Gun', type: 'strucHard', tech: 'R-Defense-WallTower-TwinAGun'},
	'Vindicator Hardpoint': 			{id: 'WallTower-SamHvy', gun: 'Vindicator SAM', type: 'strucHard', tech: 'R-Defense-WallTower-SamHvy'},
	'Vindicator SAM Site': 				{id: 'P0-AASite-SAM2', gun: 'Vindicator SAM', type: 'strucHard', tech: 'R-Defense-SamSite2'},
	'Whirlwind Hardpoint': 				{id: 'WallTower-QuadRotAAGun', gun: 'Whirlwind AA Turret', type: 'strucHard', tech: 'R-Defense-WallTower-QuadRotAA'},

	'Bombard Pit':						{id: 'Emplacement-MortarPit02', gun: 'Bombard', type: 'strucMedium', tech: 'R-Defense-HvyMor'},
	//'Flamer Guard Tower': 				{id: 'GuardTower4', gun: 'Flamer', type: 'strucMedium', tech: ''}, // unavailable
	//'Heavy Machinegun Tower': 			{id: 'GuardTower3', gun: 'Heavy Machinegun', type: 'strucMedium', tech: ''}, // unavailable
	'Hurricane AA Site': 				{id: 'AASite-QuadMg1', gun: 'Hurricane AA Turret', type: 'strucMedium', tech: 'R-Defense-AASite-QuadMg1'},
	'Incendiary Mortar Pit': 			{id: 'Emplacement-MortarPit-Incenediary', gun: 'Incendiary Mortar', type: 'strucMedium', tech: 'R-Defense-MortarPit-Incenediary'},
	'Lancer Tower': 					{id: 'GuardTower5', gun: 'Lancer', type: 'strucMedium', tech: 'R-Defense-Pillbox06'},
	'Heavy Machinegun Guard Tower': 			{id: 'GuardTower1', gun: 'Heavy Machinegun', type: 'strucMedium', tech: 'R-Defense-Tower01'},
	'Mini-Rocket Tower': 				{id: 'GuardTower6', gun: 'Mini-Rocket Pod', type: 'strucMedium', tech: 'R-Defense-Tower06'},
	'Mortar Pit': 						{id: 'Emplacement-MortarPit01', gun: 'Mortar', type: 'strucMedium', tech: 'R-Defense-MortarPit'},
	'Needle Gun Tower': 				{id: 'GuardTower-Rail1', gun: 'Needle Gun', type: 'strucMedium', tech: 'R-Defense-GuardTower-Rail1'},
	'Pepperpot Pit': 					{id: 'Emplacement-RotMor', gun: 'Pepperpot', type: 'strucMedium', tech: 'R-Defense-RotMor'},
	'Pulse Laser Tower': 				{id: 'GuardTower-BeamLas', gun: 'Pulse Laser', type: 'strucMedium', tech: 'R-Defense-PulseLas'},
	'Scourge Missile Tower': 			{id: 'GuardTower-ATMiss', gun: 'Scourge Missile', type: 'strucMedium', tech: 'R-Defense-GuardTower-ATMiss'},
	'Sunburst AA Site': 				{id: 'P0-AASite-Sunburst', gun: 'Sunburst AA', type: 'strucMedium', tech: 'R-Defense-Sunburst'},
	//'Twin Machinegun Guard Tower': 		{id: 'GuardTower2', gun: 'Twin Machinegun', type: 'strucMedium', tech: ''}, // unavailable
	'Whirlwind AA Site': 				{id: 'AASite-QuadRotMg', gun: 'Whirlwind AA Turret', type: 'strucMedium', tech: 'R-Defense-AASite-QuadRotMg'},
}

var defCats = {};

function categoriseDef() {
	for (var def in defense) {
		var type = Stats.Weapon[defense[def].gun].ImpactClass;

		if (!defCats[type]) {
			defCats[type] = [];
		}

		pushByTime(defCats, def, type);
	}
}