/*
 * Script responsible for unit coordination. Deprecated.
 */

function lockOnPlayer() {
	var nearest = -1;
	var nearestLength = 999999;

	for (var i in enemyBases) {
		if (dead[enemyBases[i].owner]) {
			dead[enemyBases[i].owner] = false;
		}
		if (enemyBases[i].owner == focusedPlayer) {
			bases[focusedPlayer] = enemyBases[i].coords;
			return focusedPlayer;
		}
	}

	if (focusedPlayer >= 0) {
		dead[focusedPlayer] = true;
	}

	for (var i = 0; i < startPositions.length; i++) {
		if (i == me || !isActivePlayer(i) || allianceExistsBetween(me, i)) { continue; }
		var path = graph.findPath(bases[me], bases[i], 'Hover');

		if (nearestLength > path.length) { nearest = i; nearestLength = path.length; }
	}

	return nearest;
}

var enemyComponents = {};
var enemyDesigns = {};

enemyComponents[propulsion['Wheels'].id] = 1;
enemyComponents[body['Viper'].id] = 1;

function analyseEnemyDesign() {
	var c = { prop: {}, gun: {}, body: {}};

	enemyDesigns = {};
	enemyDesigns[DROID_WEAPON] = {};
	enemyDesigns[DROID_CYBORG] = {};
	enemyDesigns.mods = {};

	for (var j in enemyGroups) {
		if (enemyGroups[j].owner == scavengerPlayer) { continue; }

		var units = enemyGroups[j].units;

		for (var i = 0; i < units.length; i++) {
			var template = new Template('enemy', idToName[units[i].body], idToName[units[i].propulsion], [idToName[units[i].weapons[0].id]], 'Weapon');
			var templID = template.weapons[0] + ':' + template.body + ':' + template.prop;

			if (enemyDesigns[units[i].droidType][templID]) {
				enemyDesigns[units[i].droidType][templID]++;
			} else {
				enemyDesigns[units[i].droidType][templID] = 1;
			}

			var wpnClass = turrets.Weapon[template.weapons[0]] ? turrets.Weapon[template.weapons[0]].modType : 'None';

			if (enemyDesigns.mods[wpnClass]) {
				enemyDesigns.mods[wpnClass]++;
			} else {
				enemyDesigns.mods[wpnClass] = 1;
			}

			if (!defined(enemyComponents[units[i].propulsion])) { enemyComponents[units[i].propulsion] = 1; }
			if (!defined(c.prop[units[i].propulsion])) { c.prop[units[i].propulsion] = 0; }
			c.prop[units[i].propulsion] += 1;

			if (!defined(enemyComponents[units[i].body])) { enemyComponents[units[i].body] = 1; }
			if (!defined(c.body[units[i].body])) { c.body[units[i].body] = 0; }
			c.body[units[i].body] += 1;

			if (units[i].droidType === DROID_WEAPON || units[i].droidType === DROID_CYBORG) {
				if (!defined(enemyComponents[units[i].weapons[0].id])) { enemyComponents[units[i].weapons[0].id] = 1; }
				if (!defined(c.gun[units[i].weapons[0].id])) {
					c.gun[units[i].weapons[0].id] =  0;
				}
				c.gun[units[i].weapons[0].id] += 1;
			}
		}
	}

	var counter = 0;
	for (var i in c.prop) {
		if (c.prop[i] > counter) {
			if (c.prop[i] === "CyborgLegs") {
				expectedOpponent.type = "Cyborg Propulsion";
			} else {
				expectedOpponent.type = idToName[i];
			}
			counter = c.prop[i];
		}
	}
	counter = 0;
	for (var i in c.gun) {
		if (c.gun[i].count > counter) {
			expectedOpponent.gun = idToName[i];
			counter = c.gun[i];
		}
	}
	counter = 0;
	for (var i in c.body) {
		if (c.body[i].count > counter) {
			expectedOpponent.body = idToName[i];
			counter = c.body[i];
		}
	}

	designer.enemy = new Template('e', expectedOpponent.body, expectedOpponent.type, [expectedOpponent.gun], 'Weapon');
}