/*
 *  Definition of power manager, responsible for distributing power to cores.
 */

function PowerManager() {
    this.ratios = {
        engi: 0.7,
        res: 0.1,
        prod: 0.2
    };

    this.desires = {
        engi: 0,
        res: 0,
        prod: 0
    };

    // Someone requested more power...
    this.request = function(core) {
        sendRequest('res', 'power', 'speed');
    }

    // Distribute power to cores, as per known ratios.
    this.distribute = function() {
        this.power = playerPower() - queuedPower();
    }

    // Total amount of currently distributed power.
    this.distributedTotal = function() {
        var total = 0;
        total += engiCore.power;
        total += resCore.power;
        total += prodCore.power;

        return total;
    }

    // Adjusts distribution ratios
    this.reviseRatios = function() {
        return;
    }

    // Requests power plants and power modules when appropriate
    this.checkPowerPlants = function() {
        var genCount = countStruct(struct['Power Generator'].id, me);
        if (!genCount || (genCount * 4) < countStruct(struct['Oil Derrick'].id, me)) {
            sendRequest('engi', 'Power Generator');
        } else {
            enumStruct(me, struct['Power Generator'].id).forEach(function(p) {
                if (!p.module) {
                    sendRequest('engi', 'Power Module');
                }
            });
        }
    }

    // Main process of the core.
    this.process = function() {
        this.checkPowerPlants();
        this.reviseRatios();
    }
}