/*
 *  Core request management and timeable process funtions
 */

include("/multiplay/skirmish/designerCore.js");
include("/multiplay/skirmish/engineeringCore.js");
include("/multiplay/skirmish/productionCore.js");
include("/multiplay/skirmish/researchCore.js");
include("/multiplay/skirmish/powerManager.js");
include("/multiplay/skirmish/mainCore.js");

var engiCore;
var resCore;
var prodCore;
var pmngr;
var mainCore;

// Request router
function sendRequest(target, param1, param2) {
	switch(target) {
		case 'engi': {
			engiCore.request(param1, param2);
			break;
		}
		case 'prod': {
			var type = 'droid';
			if (param1.match(/^borg/)) {
				type = 'borg';
			} else if (param1 === 'bomber' || param1 === 'fighter' || param1 === 'gunship') {
				type = 'vtol';
			}

			prodCore.request(type, param1, param2);
			break;
		}
		case 'res': {
			resCore.request(param1, param2);
			break;
		}
		case 'pmngr': {
			pmngr.request(param1);
			break;
		}
	}
}

// Queueable function to process cores.
function processMacroCores() {
	profile('processDesigner');
	profile('processPmngr');
	// profile('processMain');

	switch (mainCore.currentPlan) {
		case 'tech': {
			profile('processRes');
			profile('processProd');
			profile('processEngi');
			break;
		}
		case 'prod': {
			profile('processProd');
			profile('processEngi');
			profile('processRes');
			break;
		}
		case 'turtle': {
			profile('processEngi');
			profile('processRes');
			profile('processProd');
			break;
		}
	}
	colonel.process();
}

function processMicroCores() {
	if (focusedPlayer < 0) {
		focusedPlayer = lockOnPlayer();
	}

	colonel.sgts.forEach(function(s) {
		s.queueProduction();
		s.process();
	});
}

// Queueable and profilable process functions.
function rationPower() {
	pmngr.distribute();
}

function processEngi() {
	engiCore.process();
}

function processProd() {
	prodCore.process();
}

function processRes() {
	resCore.process();
}

function processMain() {
	mainCore.evalPlan();
}

function processPmngr() {
	pmngr.process();
}

function processDesigner() {
	designer.reviseDesigns();
}

function evalSituation() {
	mainCore.sitrep();
}