/*
 *	Definition of gorund-based micro cores.
 */

function ArmySergeantCore(role, id, prop) {
	MicroCore.call(this, AttackGroup, id, prop);
	this.role = role;
	this.type = role.match(/borg/) ? 'borg' : 'droid';
	this.prop = prop;

	prodCore.unitAmnt[this.type][this.role] += MAX_SQUAD_SIZE;
	if (role.match(/strc/)) {
		this.micro = function(enemies) {
			this.status = state.ENGAGED;
			if (!this.target) {
				this.target = this.units.pos;
			}

			var u = this.units.getUnits();

			for (var i = 0; i < u.length; i++) {
				var closest = enemies[0];
				var dist = distBetweenTwoPoints(u[i].x, u[i].y, enemies[0].x, enemies[0].y);
				var dmg = 0;
				var template = new Template('temp', idToName[u[i].body], idToName[u[i].propulsion], [idToName[u[i].weapons[0].id]], 'Weapon');
				for (var j = 0; j < enemies.length; j++) {
					// var template = new Template('temp', idToName[enemies[j].body], idToName[enemies[j].propulsion], [idToName[enemies[j].weapons[0]]], 'Weapon');
					if (dist > distBetweenTwoPoints(u[i].x, u[i].y, enemies[j].x, enemies[j].y) && template.damage(idToName[enemies[j].propulsion], idToName[enemies[j].body]) >= dmg) {
						closest = enemies[j];
						dist = distBetweenTwoPoints(u[i].x, u[i].y, enemies[j].x, enemies[j].y);
						dmg = template.damage(idToName[enemies[j].propulsion], idToName[enemies[j].body]);
					}
				}

				orderDroidObj(u[i], DORDER_ATTACK, closest);
			}
		}
	}
}

ArmySergeantCore.prototype = Object.create(MicroCore.prototype);
ArmySergeantCore.prototype.constructor = ArmySergeantCore;

/*
 *	Position holding routine.
 */
ArmySergeantCore.prototype.hold = function(point) {
	if (distance(this.units.pos, point) > PRESENCE_RADIUS) {
		this.units.move(point);
	}
}